
Ui.UI_GUESSING         ="UI_GUESSING";
local uiGuessing	 = Ui(Ui.UI_GUESSING);
uiGuessing.UIGROUP	= Ui.UI_GUESSING;

Ui:RegisterNewUiWindow("UI_GUESSING", "uiGuessing", {"a", 520, 220}, {"b", 520, 220}, {"c", 520, 220});

uiGuessing.nTimer		=  Env.GAME_FPS;

uiGuessing.Txt_Timer 	= "Txt_Timer";		--倒计时
uiGuessing.Img_Self 		= "Img_Self";		--自己的选择
uiGuessing.Txt_SelfName 	= "Txt_SelfName";	--自己名字
uiGuessing.Img_Army 		= "Img_Army";		--敌人的选择
uiGuessing.Txt_ArmyName 	= "Txt_ArmyName";	--敌人的名字

uiGuessing.Btn_JianDao 	= "Btn_JianDao";	--剪刀
uiGuessing.Btn_ShiTou 	= "Btn_ShiTou";		--石头
uiGuessing.Btn_Bu 		= "Btn_Bu";		--布
uiGuessing.Btn_Close		= "Btn_Close";		--关闭

uiGuessing.Page_Result_pg	= "Page_Result_pg";
uiGuessing.Img_Result		= "Img_Result";



uiGuessing.tbBTNImg = {
	{"\\image\\ui\\002a\\guessing\\img_jiandao_left.spr","\\image\\ui\\002a\\guessing\\img_jiandao_right.spr"},
	{"\\image\\ui\\002a\\guessing\\img_shitou_left.spr","\\image\\ui\\002a\\guessing\\img_shitou_right.spr"},
	{"\\image\\ui\\002a\\guessing\\img_bu_left.spr","\\image\\ui\\002a\\guessing\\img_bu_right.spr"},
	}

uiGuessing.tbResultImg = {"\\image\\ui\\002a\\guessing\\img_win_vn.spr", "\\image\\ui\\002a\\guessing\\img_lost_vn.spr", "", "\\image\\ui\\002a\\guessing\\img_win_vn.spr", "\\image\\ui\\002a\\guessing\\img_lost_vn.spr", ""};

uiGuessing.tbImgName = {"Kéo","Búa","Bao"};

uiGuessing.tbResultMsg = {
	"Chúc mừng, đối phương ra [<color=pink>%s<color>], bạn thắng.",
	"Thật đáng tiếc, đối phương ra [<color=pink>%s<color>], bạn thua.",
	"Đối phương ra [<color=pink>%s<color>], <color=pink>hòa, chơi lại<color>.",
	"Chúc mừng, đối phương không chọn, bạn thắng.",
	"Thật đáng tiếc, bạn chưa chọn động tác, bị thua.",
	"Hai bên đều chưa chọn động tác, <color=pink>hòa, chơi lại<color>.",
	}

function uiGuessing:Init()
	self.nTimeNum 		= 15;
	self.nTimeId 		= 0;
	self.nSelectIndex 	= 0;	--1剪刀，2石头，3布
	self.nArmySelectIndex = 0;
end

function uiGuessing:OnOpen(szSelfName, szArmyName)
	if not szArmyName or not szSelfName then
		UiManager:CloseWindow(self.UIGROUP);
	end
	self.szSelfName = szSelfName;
	self.szArmyName = szArmyName;
	Txt_SetTxt(self.UIGROUP, self.Txt_SelfName, szSelfName);
	Txt_SetTxt(self.UIGROUP, self.Txt_ArmyName, szArmyName);
	Wnd_Hide(self.UIGROUP, self.Img_Self);
	Wnd_Hide(self.UIGROUP, self.Img_Army);
	Wnd_Hide(self.UIGROUP, self.Page_Result_pg);
	self.nTimeId = Timer:Register(self.nTimer, self.UpdateTime, self);
end

function uiGuessing:Restart()
	self:UpdateResulte(self.nSelectIndex);
	self:Init();
	Wnd_Hide(self.UIGROUP, self.Img_Self);
	Wnd_Hide(self.UIGROUP, self.Img_Army);
	Wnd_SetEnable(self.UIGROUP, self.Btn_JianDao, 1);
	Wnd_SetEnable(self.UIGROUP, self.Btn_ShiTou, 1);
	Wnd_SetEnable(self.UIGROUP, self.Btn_Bu, 1);
	self.nTimeNum = 100;
	Timer:Register(3 * Env.GAME_FPS, self.UpdateTimeEx, self);
end

function uiGuessing:UpdateTimeEx()
	self.nTimeNum = 15;
	return 0;
end

function uiGuessing:OnButtonClick(szWnd, nParam)
	if (szWnd == self.Btn_JianDao) then
		self:Select(1);
	elseif (szWnd == self.Btn_ShiTou) then
		self:Select(2);
	elseif (szWnd == self.Btn_Bu) then
		self:Select(3);
	elseif (szWnd == self.Btn_Close) then
		UiManager:CloseWindow(self.UIGROUP);
	end
end

function uiGuessing:Select(nIndex)
	self.nSelectIndex = nIndex;
	--me.CallServerScript({"ApplySelecteGuessing", nIndex});
	Img_SetImage(self.UIGROUP, self.Img_Self, 1, self.tbBTNImg[nIndex][1]);
	Wnd_Show(self.UIGROUP, self.Img_Self);
	Wnd_SetEnable(self.UIGROUP, self.Btn_JianDao, 0);
	Wnd_SetEnable(self.UIGROUP, self.Btn_ShiTou, 0);
	Wnd_SetEnable(self.UIGROUP, self.Btn_Bu, 0);
end

function uiGuessing:UpdateTime()
	if self.nTimeNum >= 100 then
		return;
	end
	if self.nTimeNum <= 0 then
		self.nTimeNum = 0;
		self.nTimeId = 0;
		return 0;
	end
	local szMsg = string.format("Chọn động tác trong thời gian quy định: %s giây, sau khi chọn không thể đổi", self.nTimeNum);
	self.nTimeNum = self.nTimeNum - 1;
	Txt_SetTxt(self.UIGROUP, self.Txt_Timer, szMsg);
	return;
end

function uiGuessing:UpdateResulte(nIndex)
	self.nArmySelectIndex = nIndex;
	local nResult = self:GetResulte(self.nSelectIndex, nIndex);
	local szResult = self.tbResultImg[nResult];
	if szResult and szResult ~= "" then
		Img_SetImage(self.UIGROUP, self.Img_Result, 1, szResult);
		Wnd_Show(self.UIGROUP, self.Page_Result_pg);
	end
	Txt_SetTxt(self.UIGROUP, self.Txt_Timer, self.tbResultMsg[nResult]);
	if (self.nArmySelectIndex > 0) then
		Img_SetImage(self.UIGROUP, self.Img_Army, 1, self.tbBTNImg[self.nArmySelectIndex][2]);
		Wnd_Show(self.UIGROUP, self.Img_Army);
		Txt_SetTxt(self.UIGROUP, self.Txt_Timer, string.format(self.tbResultMsg[nResult], self.tbImgName[self.nArmySelectIndex] or ""));
	end
end

function uiGuessing:GetResulte(nIndex1, nIndex2)
	if nIndex1 > 0 and nIndex2 == 0 then
		return 4;
	end
	
	if nIndex1 == 0 and nIndex2 > 0 then
		return 5;
	end
	
	if nIndex1 == 0 and nIndex2 == 0 then
		return 6;
	end
	
	if nIndex1 - nIndex2 == 1 or (nIndex1 == 1 and nIndex2 == 3)then
		return 1;
	end
	
	if nIndex2 == nIndex1 then
		return 3;
	end
	
	return 2;
end

function uiGuessing:Close()
	if self.nTimeId > 0 and  Timer:GetRestTime(self.nTimeId) >= 0 then
		Timer:Close(self.nTimeId);
	end
end




local tCmd={ "UiManager:SwitchWindow(Ui.UI_GUESSING )", "uiGuessing", "", "Ctrl+P", "Ctrl+P", "×ÔÎÒÌÕ×í±ä×°ºÐ"};
       AddCommand(tCmd[4], tCmd[3], tCmd[2], tCmd[7] or UiShortcutAlias.emKSTATE_INGAME);
       UiShortcutAlias:AddAlias(tCmd[2], tCmd[1]);	-----¿ì½Ý¼üCtrl+L
