

Item.FILE_PATH					= "\\setting\\item\\001\\extern\\change\\";
Item.SWITCH_FILE_WUQI			= "switchwuqi.txt";
Item.SWITCH_FILE_FANGJUSHOUSHI  = "switchfangjushoushi.txt";

Item.WEAPON_SWITCH_COUNT		= 1;	-- 一次只能换一件武器的五行
Item.WEAPON_SWITCH_LEVEL_LIMIT  = 10;	-- 只有10级的武器才能换五行

Item.tbEquipType = 
{
	"Hệ ngoại công", "Hệ nội công",
}

Item.tbGDPLToValue				= {};
Item.tbValueToGDPL				= {};
Item.tbWeaponCatToDetail		= {};

Item.SECOND_FEATURE_COUNT 		= 3;		-- 二级特征key数量
Item.DEFAULT_SETTING			= "0";		-- 配置表中空列的默认值

Item.tbFixList = {
	{"Đao Thiếu","Hệ ngoại công","Da","Hệ kim",13,"Đao",},   
	{"Côn Thiếu","Hệ ngoại công","Thiết","Hệ kim",14,"Côn",},   
	{"Thương Thiên","Hệ cách đấu","Thiết","Hệ kim",15,"Thương",},   
	{"Chùy Thiên","Hệ cách đấu","Thiết","Hệ kim",16,"Chùy",},   
	{"Cạm bẫy","Hệ ngoại công","Da","Hệ mộc",22,"Phi đao",}, 
	{"Tụ tiễn","Hệ ngoại công","Da","Hệ mộc",23,"Tụ tiễn",}, 
	{"Đao Độc","Hệ ngoại công","Da","Hệ mộc",13,"Đao",},   
	{"Chưởng Độc","Hệ nội công","Da","Hệ mộc",11,"Thủ",},   
	{"Chưởng Nga","Hệ nội công","Vải","Thủy",11,"Thủ",},   
	{"Phụ Nga","Hệ nội công","Vải","Thủy",12,"Kiếm",},   
	{"Kiếm Thúy","Hệ nội công","Vải","Thủy",12,"Kiếm",},   
	{"Đao Thúy","Hệ ngoại công","Vải","Thủy",13,"Đao",},   
	{"Chưởng Cái","Hệ nội công","Da","Hệ hỏa",11,"Thủ",},   
	{"Côn Cái","Hệ ngoại công","Da","Hệ hỏa",14,"Côn",},   
	{"Chiến Nhẫn","Hệ ngoại công","Da","Hệ hỏa",15,"Thương",},   
	{"Ma Nhẫn","Hệ nội công","Da","Hệ hỏa",13,"Đao",},   
	{"Khí Võ","Hệ nội công","Vải","Hệ thổ",12,"Kiếm",},   
	{"Kiếm Võ","Hệ ngoại công","Vải","Hệ thổ",12,"Kiếm",},   
	{"Đao Côn","Hệ ngoại công","Vải","Hệ thổ",13,"Đao",},   
	{"Kiếm Côn","Hệ nội công","Vải","Hệ thổ",12,"Kiếm",},   
	{"Chùy Minh","Hệ cách đấu","Da","Hệ mộc",16,"Chùy",},   
	{"Kiếm Minh","Hệ nội công","Da","Hệ mộc",12,"Kiếm",},   
	{"Chỉ Đoàn","Hệ cách đấu","Vải","Thủy",11,"Thủ",},   
	{"Khí Đoàn","Hệ nội công","Vải","Thủy",12,"Kiếm",}, 
};

function Item:__AdjustStr(str, szException)
	if (not str or str == "") then
		return szException;
	end
	
	return str;
end


function Item:LoadSwitchSetting(szFile)
	local tbFile = Lib:LoadTabFile(szFile);
	if not tbFile then
		return;
	end
	
	
	for _, tbData in pairs(tbFile) do
		local G = tbData.Genre;
		local D = tbData.DetailType;
		local P = tbData.ParticularType;
		local L = tbData.Level;
		
		local szGDPL = string.format("%s_%s_%s_%s", G, D, P, L);
		local szFeature1 = string.format("%s_%s_%s_%s_%s_%s_%s_%s", tbData.kind5, tbData.kind6, 
			self:__AdjustStr(tbData.SuiteID, self.DEFAULT_SETTING),
			self:__AdjustStr(tbData.bVN, self.DEFAULT_SETTING), 
			self:__AdjustStr(tbData.b2, self.DEFAULT_SETTING), 
			tbData.Category, 
			self:__AdjustStr(tbData.kind4, self.DEFAULT_SETTING),
			D);
			
		local szFeature2 = string.format("%s_%s_%s", 
			self:__AdjustStr(tbData.kind3, self.DEFAULT_SETTING), 
			self:__AdjustStr(tbData.kind2, self.DEFAULT_SETTING), 
			tbData.kind7);
		
		local szFullFeature = string.format("%s_%s", szFeature1, szFeature2);
		
		self.tbGDPLToValue[szGDPL] =  {szFeature1, szFeature2};
		
		self.tbValueToGDPL[szFeature1] = self.tbValueToGDPL[szFeature1] or {};
		table.insert(self.tbValueToGDPL[szFeature1], szGDPL);

		
		if (tonumber(D) == Item.EQUIP_MELEE_WEAPON or tonumber(D) == Item.EQUIP_RANGE_WEAPON) then
			self.tbWeaponCatToDetail[tonumber(tbData.Category)] = tonumber(D);
		end
	end	
end

function Item:GetOtherFeature(nFaction, nRouteId, szSelectVSType,nEquipPos, bRepeatWeapon)
	local nId = (nFaction - 1) * 2 + nRouteId;
	local tbFeature = self.tbFixList[nId];
	if not tbFeature or nEquipPos < Item.EQUIPPOS_HEAD or nEquipPos > Item.EQUIPPOS_PENDANT then
		return;
	end
	
	bRepeatWeapon = bRepeatWeapon or 0;
	
	local szVSType = szSelectVSType; --tbFeature[2] == "Hệ nội công" and tbFeature[2] or "Hệ ngoại công";
	local szApperance = self.DEFAULT_SETTING;
	local szSeries = tbFeature[4];
	
	if (nEquipPos == Item.EQUIPPOS_WEAPON) then
		szVSType = tbFeature[2] == "Hệ nội công" and tbFeature[2] or "Hệ ngoại công";
	end
	
	if (bRepeatWeapon == 1 and nEquipPos == Item.EQUIPPOS_WEAPON) then
		szVSType = tbFeature[2];
	end
	
	if (nEquipPos == Item.EQUIPPOS_HEAD or nEquipPos == Item.EQUIPPOS_BODY) then
		szApperance = tbFeature[3];
	end
	
	local szFeature2 = string.format("%s_%s_%s", szVSType, szApperance, szSeries);
	
	local nWeaponCategory = tbFeature[5];
	
	return szFeature2, nWeaponCategory;
end

function Item:GetEquipFeatures(szGDPL, nFaction, nRouteId, szVsType, nEquipPos)
	if not self.tbGDPLToValue[szGDPL] then
		return;
	end
	
	local szFeature1 = self.tbGDPLToValue[szGDPL][1];		-- 一级特征
	local szFeature2, nWeaponCat = Item:GetOtherFeature(nFaction, nRouteId, szVsType, nEquipPos);

	if (nEquipPos == 3 ) then
		local tbFeature1 = Lib:SplitStr(szFeature1, "_");
		local nDstDetail = self.tbWeaponCatToDetail[nWeaponCat];
		if (tbFeature1[6] ~= tostring(nWeaponCat)) then
			szFeature1 = string.format("%s_%s_%s_%s_%s_%s_%s_%s", tbFeature1[1], tbFeature1[2], tbFeature1[3],
				tbFeature1[4], tbFeature1[5], tostring(nWeaponCat), tbFeature1[7], tonumber(nDstDetail));
		end
	end
	
	return szFeature1, szFeature2;
end

function Item:GetMatchEquip(szGDPL, nFaction, nRouteId, szVSType, nEquipPos)
	local szFeature1, szFeature2 = self:GetEquipFeatures(szGDPL, nFaction, nRouteId, szVSType, nEquipPos);
	
	local tbMatchGDPLs = self:GetMatchEquipByFeature(szFeature1, szFeature2);

	
	if (not tbMatchGDPLs or #tbMatchGDPLs == 0) and nEquipPos == Item.EQUIPPOS_WEAPON then
		szFeature2 = self:GetOtherFeature(nFaction, nRouteId, szVsType, nEquipPos, 1);	-- 1表示武器的重复检查
		
		tbMatchGDPLs = self:GetMatchEquipByFeature(szFeature1, szFeature2);	-- 重新获取一次
	end
	
	return tbMatchGDPLs;
end

function Item:GetMatchEquipByFeature(szFeature1, szFeature2)
	if not szFeature1 or not szFeature2 then
		return;
	end
	
	local tbMatchGDPL = self.tbValueToGDPL[szFeature1];
	if not tbMatchGDPL then
		return;
	end
	
	local tbRetGDPL = {};
	for _, szGDPL in pairs(tbMatchGDPL) do
		local szThisFeature2 = self.tbGDPLToValue[szGDPL][2];
		
		if (self:IsOtherFeatureMatch(szFeature2, szThisFeature2) == 1) then
			local tbGDPL = Lib:SplitStr(szGDPL, "_");
			for i, strValue in pairs(tbGDPL) do
				tbGDPL[i] = assert(tonumber(strValue));
			end
			
			table.insert(tbRetGDPL, tbGDPL);
		end		
	end
	
	return tbRetGDPL;
end

function Item:IsOtherFeatureMatch(szSrc, szDest)
	local tbFeatureSrc = Lib:SplitStr(szSrc, "_");
	local tbFeatureDest = Lib:SplitStr(szDest, "_");
	
	if not tbFeatureSrc or not tbFeatureDest then
		return 0;
	end
	
	if #tbFeatureSrc ~= self.SECOND_FEATURE_COUNT or #tbFeatureDest ~= self.SECOND_FEATURE_COUNT then
		return 0;
	end
	
	local szSrc1 = tbFeatureSrc[1];
	local szDest1 = tbFeatureDest[1];
	if szSrc1 ~= self.DEFAULT_SETTING and szDest1 ~= self.DEFAULT_SETTING and 
		szSrc1 ~= szDest1 then
			return 0;
		end	
	
	local szSrcAppearance = tbFeatureSrc[2];
	local szDestAppearance = tbFeatureDest[2];
	if szSrcAppearance ~= self.DEFAULT_SETTING and szDestAppearance ~= self.DEFAULT_SETTING and 
		szSrcAppearance ~= szDestAppearance then
			return 0;
		end	
	
	local szSrcSex = tbFeatureSrc[3];
	local szDestSex = tbFeatureDest[3];
	if szSrcSex ~= szDestSex then
		return 0;
	end
	
	
	return 1;
end

function Item:SwitchWeaponSeries_Check(tbGiftSelf, pPickItem, pDropItem, nX, nY)
	if pDropItem then
		if pDropItem.nEquipPos ~= Item.EQUIPPOS_WEAPON or 
			pDropItem.nLevel ~= self.WEAPON_SWITCH_LEVEL_LIMIT then
				
			me.Msg("Chỉ có thể để vào 1 vũ khí cấp 10!");
			return 0;		
		end		
		
		local nCount = 0;
		local pItem = tbGiftSelf:First();
		while(pItem) do
			nCount = nCount + 1;
			pItem = tbGiftSelf:Next();
		end
				
		if (nCount > self.WEAPON_SWITCH_COUNT - 1) then
			me.Msg("Chỉ có thể để vào 1 vũ khí cấp 10!");
			return 0;
		end		
	end
	
	return 1;
end


if (MODULE_GAMESERVER) then
	
Item.c2sFun 	= Item.c2sFun or {};
	
function Item:ApplySwitchEquipSeries()
	me.CallClientScript({"UiManager:OpenWindow", "UI_SWITCH_PANEL"});
end

function Item:ApplySwitchOK(tbSelectInfo)

	if me.CheckSwitchEquipSeriesState() ~= 1 then
		return;
	end
	
	local nRet = self:CheckInfoFormat(tbSelectInfo);
	if nRet ~= 1 then
		return;
	end	

	local nSwitchCount = 0;
	for _, bSwitch in pairs(tbSelectInfo.tbSwitchInfo) do
		nSwitchCount = bSwitch == 1 and nSwitchCount + 1 or nSwitchCount;		
	end
	
	if nSwitchCount == 0 then
		me.Msg("Chưa chọn trang bị chuyển đổi!");
		return;
	end

	local nFaction = tbSelectInfo.nFaction;
	local nRoute = tbSelectInfo.nRoute;
	local nEquipType = tbSelectInfo.nEquipType;
	local szEquipType = self.tbEquipType[nEquipType];
	local szRouteName = Player.tbRouteName[(nFaction - 1) * 2 + nRoute];
	
	local szMsg = string.format("Chuyển thành trang bị <color=yellow>%s%s<color>. ", szRouteName, szEquipType);
	if szEquipType == "Hệ nội công" then
		szMsg = szMsg.."Tuy thuộc tính cơ bản cao hơn nhưng mất đi chính xác và tránh đòn, nếu ngươi đã hoặc muốn phụ tu môn phái hệ ngoại công, dùng bộ trang bị này thì sức mạnh tương đối thấp, đồng ý chuyển không?"		
	else
		szMsg = szMsg.."Đồng ý chuyển đổi?";		
	end

	local tbOpt = 
	{
		{"Đồng ý", self.SureSwitch, self, me.nId, tbSelectInfo},
		{"Hủy"},
	}
		
	Dialog:Say(szMsg, tbOpt);
end
	
function Item:SureSwitch(nPlayerId, tbSelectInfo)
	local pPlayer = KPlayer.GetPlayerObjById(nPlayerId);
	if not pPlayer then
		return;
	end
	
	if me.CheckSwitchEquipSeriesState() ~= 1 then
		return;
	end

	local nFaction = tbSelectInfo.nFaction;
	local nRoute = tbSelectInfo.nRoute;
	if self:IsSelectFactionRoute(nFaction, nRoute) ~= 1 then
		pPlayer.Msg("Hãy gia nhập vào hệ phái chỉ định!");
		return;
	end
	
	local nEquipType = tbSelectInfo.nEquipType;
	local szEquipType = self.tbEquipType[nEquipType];
	local szRouteName = Player.tbRouteName[(nFaction - 1) * 2 + nRoute];

	local tbLogMsg = {};
	table.insert(tbLogMsg, string.format("Xin chuyển đổi trang bị thành %s%s. SwitchEquipSeries Log Begin:", szRouteName, szEquipType));
	for i = Item.EQUIPPOS_HEAD, Item.EQUIPPOS_PENDANT do			
			
		local pEquip = pPlayer.GetItem(Item.ROOM_EQUIP, i);
		if pEquip then
			
			local szCurLogMsg = string.format("Trang bị ban đầu: %s (%d_%d_%d_%d_%d_%d_%d_%d_%d_%d)", pEquip.szName,
				pEquip.nGenre, pEquip.nDetail, pEquip.nParticular, pEquip.nLevel, pEquip.nSeries, 
				pEquip.nEnhTimes, pEquip.nLucky, 0, pEquip.dwRandSeed, pEquip.nStrengthen);	
								
			if (tbSelectInfo.tbSwitchInfo[i + 1] == 1) then
				local szGDPL = string.format("%d_%d_%d_%d", pEquip.nGenre, pEquip.nDetail, pEquip.nParticular, pEquip.nLevel);
				local tbMatchGDPLs = Item:GetMatchEquip(szGDPL, tbSelectInfo.nFaction, tbSelectInfo.nRoute, szEquipType, i);
											
				local tbGDPL = nil;
				if tbMatchGDPLs then
					tbGDPL = tbMatchGDPLs[1];
				end
				
				if tbGDPL then				
					local nSeries = KItem.GetEquipBaseProp(unpack(tbGDPL)).nSeries;
					local nRet = pEquip.Regenerate(
						tbGDPL[1],
						tbGDPL[2],
						tbGDPL[3],
						tbGDPL[4],
						nSeries,
						pEquip.nEnhTimes,			-- 强化次数加一
						pEquip.nLucky,
						nil,
						0,
						pEquip.dwRandSeed,
						pEquip.nStrengthen
					);
					
					if nRet ~= 1 then
						szCurLogMsg = szCurLogMsg..string.format(", chuyển hóa thất bại!");
					else
						szCurLogMsg = szCurLogMsg..string.format(", trang bị mới: %s (%d_%d_%d_%d_%d_%d_%d_%d_%d_%d)",pEquip.szName,
							pEquip.nGenre, pEquip.nDetail, pEquip.nParticular, pEquip.nLevel, pEquip.nSeries, 
							pEquip.nEnhTimes, pEquip.nLucky, 0, pEquip.dwRandSeed, pEquip.nStrengthen);
					end
				end
			else
				szCurLogMsg = szCurLogMsg..string.format(", không chuyển đổi!");
			end
			
			table.insert(tbLogMsg, szCurLogMsg);		
		end
	end
	table.insert(tbLogMsg, string.format("Xin chuyển đổi trang bị thành %s%s. SwitchEquipSeries Log End!", szRouteName, szEquipType));
	
	for _, szLogMsg in pairs(tbLogMsg) do
		Dbg:WriteLog("SwitchEquipSeries", pPlayer.szAccount, pPlayer.szName, szLogMsg);
	end
	
	local szMsg = string.format("Chuyển đổi thành công trang bị thành <color=yellow>%s%s<color>!", szRouteName, szEquipType);
	pPlayer.Msg(szMsg);

	me.CloseSwitchEquipSeries();
	
	pPlayer.CallClientScript({"UiManager:CloseWindow", "UI_SWITCH_PANEL"});
end
Item.c2sFun["OnSwitchOK"] = Item.ApplySwitchOK;

function Item:ApplySwitchCancel()
	me.CloseSwitchEquipSeries();
end
Item.c2sFun["OnSwitchCancel"] = Item.ApplySwitchCancel;
	
function Item:IsSelectFactionRoute(nFaction, nRoute)
	if nFaction <= 0 or nFaction > Env.FACTION_NUM then
		return 0;
	end
	
	if nRoute <= 0 or nRoute > 2 then
		return 0;
	end
	
	local nMyRoute = nil;
	if nFaction == me.nFaction then  -- 如果是当前应用门派，路线以me.nRouteId为准，不取任务变量（任务变量有可能并不同步）
		nMyRoute = me.nRouteId;
	elseif (Faction:IsInit(me) == 1) then  -- 如果不是当前应用门派，且任务变量组还没有初始化，从逻辑上是讲不通的，始终验证不通过；否则取任务变量
		local tbGerneFaction = Faction:GetGerneFactionInfo(me);
		local bLearnFaction = 0;
		for _, nLearnedFaction in pairs(tbGerneFaction) do
			if (nFaction == nLearnedFaction) then
				bLearnFaction = 1;
				break;
			end
		end	
		
		if bLearnFaction == 1 then
			local nFactionGroupId = Faction.tbFactionRecGroupId[nFaction];
			nMyRoute = me.GetTask(nFactionGroupId, Faction.TSKID_FACTION_ROUTE);
		end
	end
	
	if not nMyRoute or nMyRoute ~= nRoute then
		return 0;
	end
	
	return 1;
end

function Item:CheckInfoFormat(tbSelectInfo)
	if not tbSelectInfo then
		return 0;
	end
	
	if not tbSelectInfo.nFaction or not tbSelectInfo.nRoute then
		return 0;
	end
	
	if tbSelectInfo.nFaction <= 0 or tbSelectInfo.nFaction > Env.FACTION_NUM or
		tbSelectInfo.nRoute <= 0 or tbSelectInfo.nRoute > 2 then
			
		return 0;
	end
	
	if not tbSelectInfo.tbSwitchInfo or type(tbSelectInfo.tbSwitchInfo) ~= "table" then
		return 0;
	end
	
	return 1;	
end

function Item:SwitchWeaponSeries(pPlayer)
	local szMsg = [[Chuyển ngũ hành của vũ khí thành ngũ hành chỉ định, làm vũ khí thường được kích hoạt mà không cần phải mua lại vũ khí thuộc tính khác.
Chỉ đổi ngũ hành của vũ khí, không đổi các thuộc tính khác.
]];
	local tbOpt = 
	{
		{"Chuyển thành hệ Kim", self.SureSwitchWeaponSeries, self, pPlayer.nId, Env.SERIES_METAL},
		{"Chuyển thành hệ Mộc", self.SureSwitchWeaponSeries, self, pPlayer.nId, Env.SERIES_WOOD},
		{"Chuyển thành hệ Thủy", self.SureSwitchWeaponSeries, self, pPlayer.nId, Env.SERIES_WATER},
		{"Chuyển thành hệ Hỏa", self.SureSwitchWeaponSeries, self, pPlayer.nId, Env.SERIES_FIRE},
		{"Chuyển thành hệ Thổ", self.SureSwitchWeaponSeries, self, pPlayer.nId, Env.SERIES_EARTH},
		{"Để suy nghĩ lại"},
	}
	
	Dialog:Say(szMsg, tbOpt);
end

function Item:SureSwitchWeaponSeries(nPlayerId, nSeries)
	local pPlayer = KPlayer.GetPlayerObjById(nPlayerId);
	if not pPlayer then
		return;
	end	
	
	Setting:SetGlobalObj(pPlayer);
		
	local szMsg = "Hãy để vào 1 vũ khí cấp 10."
	Dialog:OpenGift(szMsg, {"Item:SwitchWeaponSeries_Check"}, {self.SwitchWeaponSeries_OK, self, nSeries});
	
	Setting:RestoreGlobalObj()
end

function Item:SwitchWeaponSeries_OK(nSeries, tbItemObj)
	if (Lib:CountTB(tbItemObj) <= 0 or Lib:CountTB(tbItemObj) > self.WEAPON_SWITCH_COUNT) then
		me.Msg("Chỉ được để vào 1 vũ khí cấp 10!");
		return;
	end
	
	for i, tbItem in pairs(tbItemObj) do
		if tbItem[1].nEquipPos ~= Item.EQUIPPOS_WEAPON or 
			tbItem[1].nLevel ~= self.WEAPON_SWITCH_LEVEL_LIMIT then
				
				break;
			end
		
		local nRet = tbItem[1].Regenerate(tbItem[1].nGenre, tbItem[1].nDetail, tbItem[1].nParticular, tbItem[1].nLevel, 
			nSeries, tbItem[1].nEnhTimes, tbItem[1].nLucky, tbItem[1].GetGenInfo(),
			0, tbItem[1].dwRandSeed, tbItem[1].nStrengthen);
			
		Dbg:WriteLog("SwitchWeaponSeries", me.szAccount, me.szName, "Result:"..nRet);
		
		if nRet == 1 then
			me.Msg("Đã đổi thành công ngũ hành của %s thành hệ %s", tbItem[1].szName, Env.SERIES_NAME[nSeries]);
		end
	end
end

end


Item:LoadSwitchSetting(Item.FILE_PATH..Item.SWITCH_FILE_WUQI);
Item:LoadSwitchSetting(Item.FILE_PATH..Item.SWITCH_FILE_FANGJUSHOUSHI);
