local tbLuckyFan 		= Ui:GetClass("latthebai");

local tbObject 			= Ui.tbLogic.tbObject;
local tbTempItem 		= Ui.tbLogic.tbTempItem;
local tbAwardInfo 		= Ui.tbLogic.tbAwardInfo;
local tbTimer 			= Ui.tbLogic.tbTimer;

local Lottery2017 = SpecialEvent.Lottery2017;

local tbXmasLottery2012 = SpecialEvent.XmasLottery2012;

tbLuckyFan.IMG_GRID = "ImgGrid";
tbLuckyFan.BTN_CARD	= "BtnCard";
tbLuckyFan.IMG_CARD_RESULT = "ImgCardResult";
tbLuckyFan.BTN_START_GAME = "BtnStartGame";
tbLuckyFan.IMG_AWARD_GRID = "ImgAwardGrid";
tbLuckyFan.OBJ_AWARD_GRID = "ObjGrid";
tbLuckyFan.BTN_CLOSE = "BtnClose";
tbLuckyFan.IMG_OBJ = "ImageObj";
tbLuckyFan.TXT_POINT_DESC = "TxtPointWords";

tbLuckyFan.nCardNum = 25;
tbLuckyFan.nResultCardNum = 5;
tbLuckyFan.nId = 0;
tbLuckyFan.nStep = 0;

tbLuckyFan.szInfo = {};

tbLuckyFan.szPatchspr = {};

tbLuckyFan.tbPic_Card = {
		[0] = "\\image\\ui\\002a\\luckyfan\\dipai.spr",
		--[0] = "\\image\\ui\\icoiruong.spr",
		[1] = "\\setting\\item\\001\\other\\xuanjing_lv4.spr", -- Huyển Tinh 4
		[2] = "\\image\\item\\other\\scriptitem\\xuanjing_003_s.spr",-- Huyển Tinh 5
		[3] = "\\image\\item\\other\\scriptitem\\xuanjing_004_s.spr",-- Huyển Tinh 6
		[4] = "\\image\\item\\other\\scriptitem\\xuanjing_005_s.spr",-- Huyển Tinh 7
		[5] = "\\image\\item\\other\\scriptitem\\xuanjing_006_s.spr",-- Huyển Tinh 8
		[6] = "\\image\\item\\other\\scriptitem\\jingqisan_lv3.spr", -- Tinh Khí Tán (1500)
		[7] = "\\image\\item\\other\\scriptitem\\huoqisan_lv3.spr", -- Hoạt Khí Tán (1500)
		[8] = "\\image\\icon\\task\\prize_name.spr", -- Chiến Thư-Mật Thất Du Long
		[9] = "\\image\\item\\other\\scriptitem\\qingtongbaoxiang.spr", -- Rương NHHT 100
		[10] = "\\image\\item\\other\\scriptitem\\baibaoxiang_box.spr", -- Rương 6677
		[11] = "\\image\\item\\other\\scriptitem\\zongzi2.spr", -- Bánh ít bát bảo
		[12] = "\\image\\item\\other\\scriptitem\\zongzi3.spr", -- Bánh ít thập cẩm
		[13] = "\\image\\item\\other\\xoyogame\\xueyingqiang.spr", -- Huyết Ảnh Thương
		[14] = "\\image\\item\\other\\xoyogame\\baibuchuanyanggong.spr", -- Bách Bộ Xuyên Dương Cung

};

tbLuckyFan.szEffect = "\\image\\effect\\other\\zhuangbeishankuang.spr";
tbLuckyFan.szRandomPic = "\\image\\ui\\002a\\luckyfan\\img_random.spr";
tbLuckyFan.szNorEffect = "\\image\\effect\\other\\new_cheng2.spr";


function tbLuckyFan:OnOpen()
	me.CallServerScript({"Apply_Check_LatBai"});
	self.nStartStep = 0;
end

function tbLuckyFan:OnClose()
	self:StopLuckyStartTime();
	self:StopRandomShowBigSeq();
	self.nStartStep = 0;
end
function tbLuckyFan:CheckButton(nStep,nId,nInfo)
	self.nStep = nStep;
	self.nId = nId;
	self.szInfo = nInfo;
	if self.nStep >= 1 then
		self:UpdateGetCard();
		me.CallServerScript({"Apply_LoadCard"});
	end
	for i = 1, self.nCardNum do
		if (self.nStep == 1) then
			Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 1);
		else
			Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 0);
		end
	end
	self:UpdateBtnState();
	self:UpdateAwardDesc();
end
function tbLuckyFan:OnButtonClick(szWnd, nParam)
	if szWnd == self.BTN_CLOSE then
		UiManager:CloseWindow(self.UIGROUP);
		return;
	elseif (szWnd == self.BTN_START_GAME) then
		me.CallServerScript({"Apply_ActiveGame_Latbai"});
		return;
	end
	
	for i=1, self.nCardNum do
		local szBtn = self.BTN_CARD .. i;
		if (szBtn == szWnd) then
			Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 0);
			me.CallServerScript({"Apply_ClickCard_Latbai", i,self.nId});
			break;
		end
	end
	return;
end

function tbLuckyFan:UpdatePanel()
	self:UpdateFanCard();
	self:UpdateBtnState();
end
function tbLuckyFan:UpdateCardStart(nPos,AwardItem,nId)
	for i = 1, self.nCardNum do
		for j = 1, 5 do
			if i == nId[j] then
				local szPic = self.tbPic_Card[AwardItem[i]];
				Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. nId[j], 0);
				Img_SetImage(self.UIGROUP, self.BTN_CARD .. nId[j], 1, szPic);
				Img_SetImgOffset(self.UIGROUP, self.BTN_CARD .. nId[j], 2, 2);
				Img_SetImage(self.UIGROUP, self.BTN_CARD .. nId[j], 1, szPic);
				Wnd_SetEnable(self.UIGROUP, self.IMG_OBJ .. nId[j], 1);
				Wnd_SetVisible(self.UIGROUP, self.IMG_OBJ .. nId[j], 1);
				local szShowEffect = self.szNorEffect;
				if (AwardItem[i] == 1) then
					szShowEffect = self.szEffect;
				end
				Img_SetImage(self.UIGROUP, self.IMG_OBJ .. nId[j], 1, szShowEffect);
				Img_PlayAnimation(self.UIGROUP, self.IMG_OBJ .. nId[j], 1);
				Img_SetImgOffset(self.UIGROUP, self.IMG_OBJ .. nId[j], 2, 2);
				Img_SetImage(self.UIGROUP, self.IMG_CARD_RESULT .. j, 1, szPic);
				Img_SetImgOffset(self.UIGROUP, self.IMG_CARD_RESULT .. j, 2, 2);
				end
			end
	end
end
function tbLuckyFan:UpdateGetCard()
	for i = 1, self.nCardNum do
		Img_SetImage(self.UIGROUP, self.BTN_CARD .. i, 1, self.tbPic_Card[0]);
		Img_SetImgOffset(self.UIGROUP, self.BTN_CARD .. i, 0, 0);
		Wnd_SetEnable(self.UIGROUP, self.IMG_OBJ .. i, 0);
		Wnd_SetVisible(self.UIGROUP, self.IMG_OBJ .. i, 0);
		if (self.nStep == 1) then
			Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 1);
		else
			Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 0);
		end
	end
	
	for i = 1, self.nResultCardNum do
		Img_SetImage(self.UIGROUP, self.IMG_CARD_RESULT .. i, 1, self.tbPic_Card[0]);
		Img_SetImgOffset(self.UIGROUP, self.IMG_CARD_RESULT .. i, 0, 0);
	end
end

function tbLuckyFan:UpdateFanCard()
	if self.nStartStep == 1 then
		self:StartRandomShowBigSeq();
		self.nStartStep = 2 ;
		return;
	end
	self:StopRandomShowBigSeq();
	
	for i = 1, self.nCardNum do
		Img_SetImage(self.UIGROUP, self.BTN_CARD .. i, 1, self.tbPic_Card[0]);
		Img_SetImgOffset(self.UIGROUP, self.BTN_CARD .. i, 0, 0);
		Wnd_SetEnable(self.UIGROUP, self.IMG_OBJ .. i, 0);
		Wnd_SetVisible(self.UIGROUP, self.IMG_OBJ .. i, 0);
		if (self.nStep == 1) then
			Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 1);
		else
			Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 0);
		end
	end
	
	for i = 1, self.nResultCardNum do
		Img_SetImage(self.UIGROUP, self.IMG_CARD_RESULT .. i, 1, self.tbPic_Card[0]);
		Img_SetImgOffset(self.UIGROUP, self.IMG_CARD_RESULT .. i, 0, 0);
	end
end
function tbLuckyFan:UpdateCard(nPos,Iditem,nId)
	self.nId = nId;
	local szPic = self.tbPic_Card[Iditem];
	Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. nPos, 0);
	Img_SetImage(self.UIGROUP, self.BTN_CARD .. nPos, 1, szPic);
	Img_SetImgOffset(self.UIGROUP, self.BTN_CARD .. nPos, 2, 2);
	Img_SetImage(self.UIGROUP, self.BTN_CARD .. nPos, 1, self.tbPic_Card[Iditem]);
	Img_SetImage(self.UIGROUP, self.IMG_CARD_RESULT .. self.nId, 1, szPic);
	Img_SetImgOffset(self.UIGROUP, self.IMG_CARD_RESULT .. self.nId, 2, 2);
	Wnd_SetEnable(self.UIGROUP, self.IMG_OBJ .. nPos, 1);
	Wnd_SetVisible(self.UIGROUP, self.IMG_OBJ .. nPos, 1);
	local szShowEffect = self.szNorEffect;
	if (Iditem == 1) then
		szShowEffect = self.szEffect;
	end
	Img_SetImage(self.UIGROUP, self.IMG_OBJ .. nPos, 1, szShowEffect);
	Img_PlayAnimation(self.UIGROUP, self.IMG_OBJ .. nPos, 1);
	Img_SetImgOffset(self.UIGROUP, self.IMG_OBJ .. nPos, 2, 2);
end
function tbLuckyFan:OpenAll(NorPos,NorPic)
	self.nId = 0;
	for i = 1, self.nCardNum do
		if NorPos[i] == 0 then
		local szPic = self.tbPic_Card[NorPic[i]];
		Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 0);
		Img_SetImage(self.UIGROUP, self.BTN_CARD .. i, 1, szPic);
		Img_SetImgOffset(self.UIGROUP, self.BTN_CARD .. i, 2, 2);
		Img_SetImage(self.UIGROUP, self.BTN_CARD .. i, 1, szPic);
		Wnd_SetEnable(self.UIGROUP, self.IMG_OBJ .. i, 1);
		Wnd_SetVisible(self.UIGROUP, self.IMG_OBJ .. i, 1);
		local szShowEffect = self.szNorEffect;
		if (NorPic[i] == 1) then
			szShowEffect = self.szEffect;
		end
		Img_SetImage(self.UIGROUP, self.IMG_OBJ .. i, 1, szShowEffect);
		Img_PlayAnimation(self.UIGROUP, self.IMG_OBJ .. i, 1);
		Img_SetImgOffset(self.UIGROUP, self.IMG_OBJ .. i, 2, 2);
		end
	end
end
function tbLuckyFan:UpdateBtnState()
	local nStep = self.nStep;
	local szBtnMsg = string.format("Bắt đầu");
	local szDesc = "Gợi ý: Nhấn nút \"Bắt đầu\", mở [Vận may đến]";
	local nActiveState = 0;

	if (nStep == 1) then
		szBtnMsg = "Đang chơi";
		szDesc = "Gợi ý: Hãy chọn 5 Thẻ bài may mắn";
		if (self.nStartStep == 1 or self.nStartStep == 2) then
			szDesc = "Gợi ý: Đang đợi xếp lại Thẻ";
		end
	elseif (nStep == 0) then
		nActiveState = 1;
	elseif (nStep == 2) then
		szBtnMsg = "Nhận Thưởng";
		szDesc = "Bấm nhận thưởng để nhận những vật phẩm đã mở.";
		nActiveState = 1;
	end
	
	Wnd_SetEnable(self.UIGROUP, self.BTN_START_GAME, nActiveState);
	Btn_SetTxt(self.UIGROUP, self.BTN_START_GAME, szBtnMsg);
	Txt_SetTxt(self.UIGROUP, self.TXT_POINT_DESC, szDesc);
end
function tbLuckyFan:UpdateAwardDesc()
	for i, tbRow in ipairs(self.szInfo) do
		local tbGDPL = self.split(self.szInfo[i],",");
		local tbG = tonumber(tbGDPL[1]);
		local tbD = tonumber(tbGDPL[2]);
		local tbP = tonumber(tbGDPL[3]);
		local tbL = tonumber(tbGDPL[4]);
		local ObjItem = self.OBJ_AWARD_GRID .. i;
		Wnd_SetVisible(self.UIGROUP, ObjItem, 1);
		Wnd_SetEnable(self.UIGROUP,ObjItem, 1);
		local pItem = KItem.CreateTempItem(tbG, tbD, tbP, tbL, 0);
		if pItem then
			ObjMx_AddObject(self.UIGROUP, ObjItem, Ui.CGOG_ITEM, pItem.nIndex, 0, 0);
		end
	end
end
function tbLuckyFan:OnObjHover(szWnd, uGenre, uId, nX, nY)
	local pItem = KItem.GetItemObj(uId);
	if pItem then
		Wnd_ShowMouseHoverInfo(self.UIGROUP, szWnd, pItem.GetCompareTip(Item.TIPS_BINDGOLD_SECTION));
	end
end
function tbLuckyFan:StartGame()
	self:StopLuckyStartTime();
	self.nStartStep = 1;
	self:UpdatePanel();
	self.nTimer_PlayerLuckyStartId = tbTimer:Register(3 * 18, self.NextStep, self);
end

function tbLuckyFan:StopLuckyStartTime()
	if (self.nTimer_PlayerLuckyStartId and self.nTimer_PlayerLuckyStartId ~= 0) then
		tbTimer:Close(self.nTimer_PlayerLuckyStartId);
		self.nTimer_PlayerLuckyStartId = 0;
	end
end

function tbLuckyFan:NextStep()
	if (not self.nStartStep or self.nStartStep <= 0) then
		return 0;
	end
	
	self.nStartStep = self.nStartStep + 1;
	self:UpdatePanel();
	if (self.nStartStep == 2) then
		return;
	end
	self.nStartStep = 0;
	self.nTimer_PlayerLuckyStartId = 0;
	return 0;
end
function tbLuckyFan:StartRandomShowBigSeq()
	self:StopRandomShowBigSeq();
	self.nTimer_PlayerRandomShowId = tbTimer:Register(2, self.RandomShowBigSeq, self);
end

function tbLuckyFan:StopRandomShowBigSeq()
	if (self.nTimer_PlayerRandomShowId and self.nTimer_PlayerRandomShowId > 0) then
		tbTimer:Close(self.nTimer_PlayerRandomShowId);
		self.nTimer_PlayerRandomShowId = 0;		
	end
end

function tbLuckyFan:RandomShowBigSeq()
	for i = 1, self.nCardNum do
		local nRandom = MathRandom(1,15); -- ramdom 10 item vật phẩm
		local szRandomPic = self.tbPic_Card[nRandom];
		Img_SetImage(self.UIGROUP, self.BTN_CARD .. i, 1, szRandomPic);
		Img_SetImgOffset(self.UIGROUP, self.BTN_CARD .. i, 2, 2);
		Img_PlayAnimation(self.UIGROUP, self.BTN_CARD .. i, 1);
		Wnd_SetEnable(self.UIGROUP, self.IMG_OBJ .. i, 0);
		Wnd_SetVisible(self.UIGROUP, self.IMG_OBJ .. i, 0);
		Wnd_SetEnable(self.UIGROUP, self.BTN_CARD .. i, 0);
	end
	return;
end
function tbLuckyFan:split(delimiter)
  local result = { }
  local from  = 1
  local delim_from, delim_to = string.find( self, delimiter, from  )
  while delim_from do
    table.insert( result, string.sub( self, from , delim_from-1 ) )
    from  = delim_to + 1
    delim_from, delim_to = string.find( self, delimiter, from  )
  end
  table.insert( result, string.sub( self, from  ) )
  return result
end

