local uiOTT = Ui:GetClass("ott_ui");

local tbObject   = Ui.tbLogic.tbObject;
local tbMouse    = Ui.tbLogic.tbMouse;
local tbTempItem = Ui.tbLogic.tbTempItem;
local tbTimer	 = Ui.tbLogic.tbTimer;


uiOTT.OBJ_OTT 					= "ObjOTT";
uiOTT.OBJ_ITEM_PLAYER 			= "ObjItemPlayer";
uiOTT.BTN_INDEX 				= "BtnInDex";
uiOTT.IMG_SHOWME 				= "ImageShowMe";
uiOTT.IMG_SHOWPLAYER			= "ImageShowPlayer";
uiOTT.LOCK_OTT_BUTTON			= "BtnLock";	
uiOTT.ACCEP_OTT_BUTTON			= "BtnAccep";
uiOTT.TXT_NAMEPLAYER			= "TxtNamePlayer";
uiOTT.TXT_LOCKPLAYER			= "TxtLockPlayer";
uiOTT.AFFIRM_OTT_BUTTON			= "BtnAffirm";
uiOTT.TXT_STATUS				= "TxtStatus";
uiOTT.CANCEL_OTT_BUTTON			= "BtnCancel";		
uiOTT.CLOSE_BUTTON				= "BtnClose";

uiOTT.tbPic_Index = {
		[0] = "",
		[1] = "\\image\\ui\\Keo.spr",
		[2] = "\\image\\ui\\Bua.spr",
		[3] = "\\image\\ui\\Bao.spr",
};

local tbOTTCont = {bShowCd = 0, bUse = 0, bLink = 0, nRoom = 16};

function uiOTT:Init()
	self.szPlayerName		= "";
	self.nFreezeTime		= 0;
	self.nTimerId			= 0;
	self.nStep				= 0;
	self.nSelect			= 0;
	self.nItem				= 0;
	self.PlayerLock			= 0;
	self.MeLock				= 0;
	self.PlayerAccp			= 0;
	self.MeAccp				= 0;
	self.Send				= 0;
end

function tbOTTCont:CheckSwitchItem(pDrop, pPick, nX, nY)
	if not pDrop then
		return 1;
	end
	if (pDrop.IsBind() == 1) then
		me.Msg("Vật phẩm (khóa) không thể đặt cược.");
		return 0;
	end
	if (pDrop.nCount > 1) then
		me.Msg("Chỉ được phép đặt 1 vật phẩm, vui lòng tách vật phẩm ra.");
		return 0;
	end
	if pDrop.nGenre == Item.SCRIPTITEM then
		return 1;
	else
		me.Msg("Vật phẩm không thể đặt cược.");
		return 0;
	end
end

function uiOTT:OnCreate()
	self.tbOTTCont = tbObject:RegisterContainer(
		self.UIGROUP,
		self.OBJ_OTT,
		Item.ROOM_OTT_WIDTH,
		Item.ROOM_OTT_HEIGHT,
		tbOTTCont,
		"itemroom"
	);
end
function uiOTT:OnOpen()
	Wnd_SetEnable(self.UIGROUP, self.AFFIRM_OTT_BUTTON, self.nStep);
	UiManager:SetUiState(UiManager.UIS_TRADE_PLAYER);
	UiManager:OpenWindow(Ui.UI_ITEMBOX);
end
function uiOTT:OnButtonClick(szWnd, nParam)

	if (szWnd == self.CANCEL_OTT_BUTTON) or (szWnd == self.CLOSE_BUTTON) then
		UiManager:CloseWindow(self.UIGROUP);
	end
	for i = 1, 3 do
		local szBtn = self.BTN_INDEX .. i;
		if (szBtn == szWnd) then
			if self.nStep == 0 then
				me.Msg("Xin vui lòng khóa rồi hãy lựa chọn.");
			elseif self.nStep == 1 then
				self.nSelect = i;
				Img_SetImage(self.UIGROUP, self.IMG_SHOWME , 1, self.tbPic_Index[self.nSelect]);
			end
		end
	end
	
	if (szWnd == self.LOCK_OTT_BUTTON) then
		self.OnStartGame();
	end
	
	if (szWnd == self.AFFIRM_OTT_BUTTON) then
		if self.nSelect > 0 then
			me.CallServerScript({"Accecp_OTT",self.nSelect});
		else
			me.Msg("Xin vui lòng chọn (kéo búa bao)");
			Btn_Check(self.UIGROUP, self.AFFIRM_OTT_BUTTON, 0);
		end
	end
	return;
end

function uiOTT:UpdatePage(mData)
	self.nFreezeTime		= OTTClient:GetTime(me);
	self.szPlayerName		= mData.PlayerName;
	Txt_SetTxt(self.UIGROUP, self.TXT_NAMEPLAYER,self.szPlayerName);
	self.nTimerId = tbTimer:Register(18, self.OnTimer, self);
end
function uiOTT:LockGame(lData)
	self.MeLock = OTTClient:GetMeLock(me);
	if self.PlayerLock == 1 and self.MeLock == 1 then
		self.nFreezeTime = OTTClient:GetTime(me);
		self.nStep		 = OTTClient:GetStep(me);
	end
	Wnd_SetEnable(self.UIGROUP, self.LOCK_OTT_BUTTON, 0);
	Wnd_SetEnable(self.UIGROUP, self.OBJ_OTT, 0);
	Wnd_SetEnable(self.UIGROUP, self.AFFIRM_OTT_BUTTON, 1);
end
function uiOTT:UpdatePlayerFinishGame()
	local nText = "<bclr=blue><color=white>Đối phương đã chọn xong.<color><bclr>";
	Txt_SetTxt(self.UIGROUP, self.TXT_LOCKPLAYER,nText);
	self.PlayerAccp = OTTClient:GetpAccp(me);
	if self.MeAccp == 1 and self.PlayerAccp == 1 then
		self.nFreezeTime = OTTClient:GetTime(me);
		self.nStep = OTTClient:GetStep(me);
	end
end
function uiOTT:UpdateKetqua(Fdata)
	self.nFreezeTime = OTTClient:GetTime(me);
	self.nStep = OTTClient:GetStep(me);
	local nText = "Trò Chơi Kết Thúc.";
	Txt_SetTxt(self.UIGROUP, self.TXT_LOCKPLAYER,nText);
	Img_SetImage(self.UIGROUP, self.IMG_SHOWPLAYER , 1, self.tbPic_Index[Fdata.nIndex]);
	Txt_SetTxt(self.UIGROUP, self.TXT_STATUS, Fdata.nMsg);
end
function uiOTT:EndGame()
	self.MeAccp = OTTClient:GetmAccp(me);
	if self.MeAccp == 1 and self.PlayerAccp == 1 then
		self.nFreezeTime = OTTClient:GetTime(me);
		self.nStep = OTTClient:GetStep(me);
	end
	Wnd_SetEnable(self.UIGROUP, self.AFFIRM_OTT_BUTTON, 0);
	for i = 1, 3 do
		local szBtn = self.BTN_INDEX .. i;
		Wnd_SetEnable(self.UIGROUP, szBtn, 0);
	end
end
function uiOTT:UpdatePlayer(nData)
	for i = 1, Item.ROOM_OTT_WIDTH do
		if nData[i].nIndex == 1 then
			local ObjItem = self.OBJ_ITEM_PLAYER .. i;
			local pItem = KItem.CreateTempItem(nData[i].nGenre, nData[i].nDetail, nData[i].nParticular, nData[i].nLevel, 0);
			if pItem then
				ObjMx_AddObject(self.UIGROUP, ObjItem, Ui.CGOG_ITEM, pItem.nIndex, 0, 0);
			end
		end
	end
	local nText = "<bclr=red><color=white>Đối phương đã khóa<color><bclr>";
	Txt_SetTxt(self.UIGROUP, self.TXT_LOCKPLAYER,nText);
	
	self.PlayerLock = OTTClient:GetpLock(me);
	if self.PlayerLock == 1 and self.MeLock == 1 then
		self.nStep = OTTClient:GetStep(me);
		self.nFreezeTime = OTTClient:GetTime(pPlayer);
	end
end

function uiOTT:OnObjHover(szWnd, uGenre, uId, nX, nY)
	local pItem = KItem.GetItemObj(uId);
	if pItem then
		Wnd_ShowMouseHoverInfo(self.UIGROUP, szWnd, pItem.GetCompareTip(Item.TIPS_BINDGOLD_SECTION));
	end
end

function uiOTT:OnTimer()
	self.nFreezeTime = self.nFreezeTime - 1;
	if (self.nFreezeTime > 0) then
		if self.nStep == 0 then
			Txt_SetTxt(self.UIGROUP, self.TXT_STATUS, "Bạn có (<color=yellow>"..self.nFreezeTime.."<color> giây) để đưa vật phẩm vào và khóa.");
			if self.MeLock == 1 then
				Txt_SetTxt(self.UIGROUP, self.TXT_STATUS, "  <bclr=red><color=white>Vui lòng chờ đối phương khóa.<color><bclr>");
			end
		elseif self.nStep == 1 then
			if self.PlayerLock == 1 and self.MeLock == 1 then
			Txt_SetTxt(self.UIGROUP, self.TXT_STATUS, "Bạn có (<color=yellow>"..self.nFreezeTime.."<color> giây) để chọn. (Kéo - Búa - Bao)");
			end
			if self.MeAccp == 1 then
				Txt_SetTxt(self.UIGROUP, self.TXT_STATUS, "Vui lòng chờ đối phương Chọn.");
			end
		elseif self.nStep == 2 then
			Txt_SetTxt(self.UIGROUP, self.TXT_STATUS, "Vui lòng chờ kết quả.");
		end
		if self.MeAccp == 1 and self.PlayerAccp == 1 and self.nStep == 2 and self.Send == 0 then
			self.Send = 1;
			me.CallServerScript({"Accecp_OTT",Item.ROOM_OTT_WIDTH});
		end
	else
		UiManager:CloseWindow(self.UIGROUP);
		tbTimer:Close(self.nTimerId);
		self.nTimerId = 0;
	end
end

function uiOTT:Cancel()
	if (self.nFreezeTime < 2) then
		if self.MeLock == 0 then
			me.Msg("<color=yellow>Thao tác bị gián đoạn, Bạn đã bị hủy cuộc chơi.<color>"); -- khong khoa nen uot
			return 0;
		end
	else
		me.Msg("<color=yellow>Đối phương đã hủy cuộc chơi.<color>");-- doi phuong huy
	end
	UiManager:CloseWindow(self.UIGROUP);-- nếu a xóa ở trên là bên b k thể uot ott khi bên a huy
	tbTimer:Close(self.nTimerId);
	self.nTimerId = 0;
end
function uiOTT:OnClose()
	for i = 1, Item.ROOM_OTT_WIDTH do
		local ObjItem = self.OBJ_ITEM_PLAYER .. i;
		ObjMx_Clear(self.UIGROUP, ObjItem);
	end
	me.CallServerScript({"Cancel_OTT",self.szPlayerName});
	self.tbOTTCont:ClearRoom();
	UiManager:ReleaseUiState(UiManager.UIS_TRADE_PLAYER);
	if (self.nTimerId ~= 0) then
		tbTimer:Close(self.nTimerId);		-- 关闭计时器
		self.nTimerId = 0;
	end	
end
function uiOTT:OnDestroy()
	tbObject:UnregContainer(self.tbOTTCont);
end
function uiOTT:OnStartGame()
	local nData = {};
	local nItem = 0;
	for i = 0, Item.ROOM_OTT_WIDTH - 1 do
		local pItem = me.GetItem(16, i, 0);
		nData[i+1] = {};
		nData[i+1].nIndex = 0;
		if pItem then
			nItem = 1;
			nData[i+1].nIndex		= 1;
			nData[i+1].nGenre		= pItem.nGenre;
			nData[i+1].nDetail		= pItem.nDetail;
			nData[i+1].nParticular	= pItem.nParticular;
			nData[i+1].nLevel		= pItem.nLevel;
			nData[i+1].ndwId 		= pItem.dwId;
		end
	end
	if nItem == 0 then
		me.Msg("Xin vui đặt ít nhất 1 vật phẩm để tham gia.");
		Btn_Check(self.UIGROUP, self.LOCK_OTT_BUTTON, 0);
		return 0;
	end
	me.CallServerScript({"Player_Lock_OTT",nData});
end
function uiOTT:RegisterEvent()
	local tbRegEvent = {};
	tbRegEvent = Lib:MergeTable(tbRegEvent, self.tbOTTCont:RegisterEvent());
	return tbRegEvent;
end
function uiOTT:RegisterMessage()
	local tbRegMsg = {};
	tbRegMsg = Lib:MergeTable(tbRegMsg, self.tbOTTCont:RegisterMessage());
	return tbRegMsg;
end