




local tbSelectNpc= Ui:GetClass("selectnpc");
local tbTimer = Ui.tbLogic.tbTimer;

tbSelectNpc.IMG_PARTNER	= "ImgPartner";
tbSelectNpc.IMG_PLAYER_PORTRAIT	= "ImgPortrait";
tbSelectNpc.PROGRESS_LIFE 		= "ImgPartLife";
tbSelectNpc.PROGRESS_MANA 		= "ImgPartMana";
tbSelectNpc.TEXT_LEVEL 			= "TxtLevel";
tbSelectNpc.TEXT_LIFE			= "TxtLife";
tbSelectNpc.TEXT_MANA			= "TxtMana";
tbSelectNpc.TEXT_NAME			= "TxtName";
tbSelectNpc.WND_SHORTCUR		= "ShortCut";
tbSelectNpc.BTN_LOOK			= "Btn_Look";
tbSelectNpc.BTN_FRIEND			= "Btn_Friend";
tbSelectNpc.BTN_TRADE			= "Btn_Trade";
tbSelectNpc.BTN_FOLLOW			= "Btn_Follow";
tbSelectNpc.BTN_OTT				= "Btn_OTT";

tbSelectNpc.SPR_NPC_PORTRAIT_GOLD	= "\\image\\icon\\npc\\portrait\\portrait_npc_gold"..UiManager.IVER_szVnSpr;
tbSelectNpc.SPR_NPC_PORTRAIT_WOOD	= "\\image\\icon\\npc\\portrait\\portrait_npc_wood"..UiManager.IVER_szVnSpr;
tbSelectNpc.SPR_NPC_PORTRAIT_WATER = "\\image\\icon\\npc\\portrait\\portrait_npc_water"..UiManager.IVER_szVnSpr;
tbSelectNpc.SPR_NPC_PORTRAIT_FIRE	= "\\image\\icon\\npc\\portrait\\portrait_npc_fire"..UiManager.IVER_szVnSpr;
tbSelectNpc.SPR_NPC_PORTRAIT_EARTH	= "\\image\\icon\\npc\\portrait\\portrait_npc_earth"..UiManager.IVER_szVnSpr;
tbSelectNpc.SKILLID_STATE		= 379;
tbSelectNpc.REFRESHTIME			= Env.GAME_FPS / 2;	-- 定时刷新时间，1/2 秒

function tbSelectNpc:Init()
	self.nTimerId 		= 0;
	self.pPlayerInfo	= nil;
end

function tbSelectNpc:OnOpen(pNpc)
	if (not pNpc) then
		return 0;
	end
	Wnd_Hide(self.UIGROUP, self.IMG_PARTNER);
	self.pPlayerInfo = pNpc;
	if (self.pPlayerInfo and self.pPlayerInfo.nKind >= 0 and self.pPlayerInfo.nKind <= 3) then
		if self.pPlayerInfo.nKind == 1 then
			Wnd_Show(self.UIGROUP, self.WND_SHORTCUR);
		else
			Wnd_Hide(self.UIGROUP, self.WND_SHORTCUR);
			if Partner and Partner.tbPartnerAttrib and Partner.tbPartnerAttrib[pNpc.nTemplateId] then
				Wnd_Show(self.UIGROUP, self.IMG_PARTNER);
			end
		end
	end
	self.pPlayerInfo.AddTaskState(self.SKILLID_STATE) -- 画圈圈
	self:TimerRegister();
	self:UpdatePlayerState();
	return 1;
end

function tbSelectNpc:OnClose()
	if self.nTimerId and (self.nTimerId ~= 0) then
		tbTimer:Close(self.nTimerId);
		self.nTimerId = 0;
	end
	if (self.pPlayerInfo) then
		self.pPlayerInfo.RemoveTaskState(self.SKILLID_STATE);
	end
end

function tbSelectNpc:UpdatePlayerState()
	local pNpc	= KNpc.GetById(self.pPlayerInfo.dwId);
	if pNpc == nil then
		UiManager:CloseWindow(self.UIGROUP);
		return;
	end
	self.pPlayerInfo = pNpc;
	self:UpdateLife();
	self:UpdateMana();
	self:UpdateLevel();
	self:UpdateName();
	self:UpdatePortrait();
end

function tbSelectNpc:UpdateLife()
	Prg_SetPos(self.UIGROUP, self.PROGRESS_LIFE, self.pPlayerInfo.nCurLife / self.pPlayerInfo.nMaxLife * 1000);
	Txt_SetTxt(self.UIGROUP, self.TEXT_LIFE, self.pPlayerInfo.nCurLife.."/"..self.pPlayerInfo.nMaxLife);
end

function tbSelectNpc:UpdateMana()
	local nMaxMana = 0;
	if self.pPlayerInfo.nMaxMana == 0 or self.pPlayerInfo.nMaxMana == nil then
		nMaxMana = 100;
	else
		nMaxMana = self.pPlayerInfo.nMaxMana;
	end
	Prg_SetPos(self.UIGROUP, self.PROGRESS_MANA, self.pPlayerInfo.nCurMana / nMaxMana * 1000);
end

function tbSelectNpc:UpdateLevel()
	Txt_SetTxt(self.UIGROUP, self.TEXT_LEVEL, self.pPlayerInfo.nLevel);
end

function tbSelectNpc:UpdateName()
	Txt_SetTxt(self.UIGROUP, self.TEXT_NAME, self.pPlayerInfo.szName);
end

function tbSelectNpc:UpdatePortrait()
	local nSex	= self.pPlayerInfo.nSex;
	
	if (nSex < 0) then	-- NPC无性别，判断战斗npc的头像按五行划分（edited by kenmasterwu）
    
    local nKind = self.pPlayerInfo.nKind;
    local nSeries = self.pPlayerInfo.nSeries;
    if   (self.pPlayerInfo and nKind == 0) then 
       if (nSeries == 1) then
	        Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, self.SPR_NPC_PORTRAIT_GOLD);
	     elseif (nSeries == 2) then
	        Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, self.SPR_NPC_PORTRAIT_WOOD);
	     elseif (nSeries == 3) then
	        Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, self.SPR_NPC_PORTRAIT_WATER);
	     elseif (nSeries == 4) then
	        Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, self.SPR_NPC_PORTRAIT_FIRE);   
	     elseif (nSeries == 5) then
	        Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, self.SPR_NPC_PORTRAIT_EARTH);
	     else
	        Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, "");
	     end
	  else
	     Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, "");
	  end  
		return;
	end
	local szSpr = GetPortraitSpr(self.pPlayerInfo.nPortrait, nSex);
	Img_SetImage(self.UIGROUP, self.IMG_PLAYER_PORTRAIT, 1, szSpr);
end

function tbSelectNpc:OnButtonClick(szWnd, nParam)
	if szWnd ==	self.BTN_LOOK then
		
		local bSucess = ProcessNpcById(self.pPlayerInfo.dwId, UiManager.emACTION_VIEWITEM);
		if (bSucess == 0) then
			UiManager:CloseWindow(Ui.UI_VIEWPLAYER);		
			me.Msg("Muốn xem thông tin của người chơi này, nhưng khoảng cách quá xa!")
		end
		
	elseif szWnd == self.BTN_FRIEND then
		ProcessNpcById(self.pPlayerInfo.dwId, UiManager.emACTION_MAKEFRIEND);
	elseif szWnd == self.BTN_TRADE then
		ProcessNpcById(self.pPlayerInfo.dwId, UiManager.emACTION_TRADE);
	elseif szWnd == self.BTN_FOLLOW then
		ProcessNpcById(self.pPlayerInfo.dwId, UiManager.emACTION_FOLLOW);
	elseif szWnd == self.BTN_OTT then
		me.CallServerScript({"Send_Post_Player_OTT",self.pPlayerInfo.dwId,self.pPlayerInfo.szName});
	end
end
function tbSelectNpc:TimerRegister()
	self.nTimerId = tbTimer:Register(self.REFRESHTIME, self.OnTimer, self);
end

function tbSelectNpc:OnTimer()
	if (self.pPlayerInfo) then
		self:UpdatePlayerState();
	end
end
