
local uiTeamPortrait = Ui:GetClass("teamportrait");

uiTeamPortrait.CLOSE_BUTTON		= "BtnClose";
uiTeamPortrait.PORTRAIT_WINDOW 	= "WndPortrait";
uiTeamPortrait.TIME_TALKPOPSHOWTIME = 6;

uiTeamPortrait.PORTRAIT_WND =	-- 控件句柄表
{
	{ "ImgMember1", "ImgPortrait1", "ImgPartBlood1", "ImgPartPower1", "TxtName1", "ImgFaction1" , "TxtLevel1"},
	{ "ImgMember2", "ImgPortrait2", "ImgPartBlood2", "ImgPartPower2", "TxtName2", "ImgFaction2"	, "TxtLevel2"},
	{ "ImgMember3", "ImgPortrait3", "ImgPartBlood3", "ImgPartPower3", "TxtName3", "ImgFaction3"	, "TxtLevel3"},
	{ "ImgMember4", "ImgPortrait4", "ImgPartBlood4", "ImgPartPower4", "TxtName4", "ImgFaction4"	, "TxtLevel4"},
	{ "ImgMember5", "ImgPortrait5", "ImgPartBlood5", "ImgPartPower5", "TxtName5", "ImgFaction5"	, "TxtLevel5"},
};   -- [1]为PlayerID

uiTeamPortrait.MENU_ITEM = { " Mật ", " Xem ",  " Giao dịch ", " Theo ", " Rời đội ", " Thêm bạn ", " Chuyển quyền ", " Trục xuất " , " Oẳn Tù Xì " };

uiTeamPortrait.ZHENFA_WND = {"ImgZhenFa", "ImgZhenFaChange"};

uiTeamPortrait.FACTION_FLAG =
{
	"\\image\\icon\\player\\faction\\team_member_faction_flag_shaolin.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_tianwang.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_tangmen.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_wudu.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_emei.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_cuiyan.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_gaibang.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_tianren.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_wudang.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_kunlun.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_mingjiao.spr",
	"\\image\\icon\\player\\faction\\team_member_faction_flag_dali.spr",
};

uiTeamPortrait.ZHENGFA_SPR = 
{
	"image\\ui\\001a\\zhen\\zhenfa00.spr",
	"image\\ui\\001a\\zhen\\zhenfa01.spr",
	"image\\ui\\001a\\zhen\\zhenfa02.spr",
	"image\\ui\\001a\\zhen\\zhenfa03.spr",
	"image\\ui\\001a\\zhen\\zhenfa04.spr",
	"image\\ui\\001a\\zhen\\zhenfa05.spr",
}

uiTeamPortrait.PO_WND = {
	{"Member1_PoPo", "Member1_PoPo_Txt"},
	{"Member2_PoPo", "Member2_PoPo_Txt"},
	{"Member3_PoPo", "Member3_PoPo_Txt"},
	{"Member4_PoPo", "Member4_PoPo_Txt"},
	{"Member5_PoPo", "Member5_PoPo_Txt"},
};

function uiTeamPortrait:Init()
	self.m_bHidePortrait	= 0;
	self.m_tbPlayerId		= { 0, 0, 0, 0, 0 };
	self.tbTalkTime			= { 0, 0, 0, 0, 0 };
end

function uiTeamPortrait:OnOpen()
	self:GetMemberBaseData();
	self.tbMenuFun = {
		{ self.CmdChat },
		{ self.CmdViewPlayer },
		{ self.CmdTrade },
		{ self.CmdFollow },
		{ self.CmdLeaveTeam },
		{ self.CmdAddFriend},
		{ self.CmdOTT}
					
	}
	
	for i=1, #self.PO_WND do
		Wnd_Hide(self.UIGROUP, self.PO_WND[i][1]);
	end
	self.tbTalkTime = {0, 0, 0, 0, 0};
	self.nTimerRegisterId = Ui.tbLogic.tbTimer:Register(1 * 18, self.HideTalk, self);
end

function uiTeamPortrait:OnClose()
	if (self.nTimerRegisterId and self.nTimerRegisterId > 0) then
		Ui.tbLogic.tbTimer:Close(self.nTimerRegisterId);
	end
	self.nTimerRegisterId = 0;
end

function uiTeamPortrait:OnButtonClick(szWndName, nParam)
	if szWndName == self.CLOSE_BUTTON then
		self:MinProtraitWindow();
	end
end

function uiTeamPortrait:GetMemberBaseData()
	local tbMember = me.GetTeamMemberInfo();
	local nMemberCount = #tbMember;
	
	for i = 1, #self.PORTRAIT_WND do

		if tbMember[i] and tbMember[i].szName and tbMember[i].nPlayerID then
			self.m_tbPlayerId[i] = tbMember[i].nPlayerID;
			if tbMember[i].nPortrait then
				local szSpr = GetPortraitSpr(tbMember[i].nPortrait, tbMember[i].nSex, 1);
				Img_SetImage(self.UIGROUP, self.PORTRAIT_WND[i][2], 1, szSpr);
			end

			Prg_SetPos(self.UIGROUP, self.PORTRAIT_WND[i][3], tbMember[i].nCurLife / 100 * 1000);
			Prg_SetPos(self.UIGROUP, self.PORTRAIT_WND[i][4], tbMember[i].nCurMana / 100 * 1000);
			local szFaction = Player:GetFactionRouteName(tbMember[i].nFaction);
			local szName = GetMapNameFormId(tbMember[i].nMapId)
			if not szName then
				szName = "Chưa biết"
			end
			Wnd_SetTip(self.UIGROUP, self.PORTRAIT_WND[i][2], string.format("Cấp: %d; %s; %s", tbMember[i].nLevel, szFaction, szName));
			
			if tbMember[i].nOnline == 0 then
				Txt_SetTxtColor(self.UIGROUP, self.PORTRAIT_WND[i][5], 0xc0c0c0);
				Img_SetFrame(self.UIGROUP, self.PORTRAIT_WND[i][2], 1);
			else
				Txt_SetTxtColor(self.UIGROUP, self.PORTRAIT_WND[i][5], 0x80d0a0);
				Img_SetFrame(self.UIGROUP, self.PORTRAIT_WND[i][2], 0);
			end

			local szBuf = tbMember[i].szName;
			if tbMember[i].nLeader == 1 then
				szBuf = "<color=0xffff68>"..szBuf;	-- 队长
			end
			Txt_SetTxt(self.UIGROUP, self.PORTRAIT_WND[i][5], szBuf)
			
			if self.FACTION_FLAG[tbMember[i].nFaction] then
				Img_SetImage(self.UIGROUP, self.PORTRAIT_WND[i][6], 1, self.FACTION_FLAG[tbMember[i].nFaction]);
			else
				Img_SetImage(self.UIGROUP, self.PORTRAIT_WND[i][6], 1, "");
			end
			Wnd_Show(self.UIGROUP, self.PORTRAIT_WND[i][1]);
		else
			Txt_SetTxt(self.UIGROUP, self.PORTRAIT_WND[i][5], "");
			Wnd_Hide(self.UIGROUP, self.PORTRAIT_WND[i][1]);
		end
	end
	
	local tbZhenFa = me.GetZhenFaInfo();
	if (not tbZhenFa) then
		return;
	end;

	Wnd_SetPos(self.UIGROUP, self.ZHENFA_WND[1], 2, (nMemberCount + 1) * 34);
	Img_SetImage(self.UIGROUP, self.ZHENFA_WND[1], 1, self.ZHENGFA_SPR[tbZhenFa.nLevel + 1]);
	Wnd_Show(self.UIGROUP, self.ZHENFA_WND[1]);
	
end

function uiTeamPortrait:UpdateMemberData(nZhenFaChange)

	local tbMember = me.GetTeamMemberInfo();
	for i = 1, #self.PORTRAIT_WND do
		if tbMember[i] then
			Prg_SetPos(self.UIGROUP, self.PORTRAIT_WND[i][3], tbMember[i].nCurLife / 100 * 1000);
			Prg_SetPos(self.UIGROUP, self.PORTRAIT_WND[i][4], tbMember[i].nCurMana / 100 * 1000);
			local szFaction = Player:GetFactionRouteName(tbMember[i].nFaction);
			local szName = GetMapNameFormId(tbMember[i].nMapId)
			if not szName then
				szName = "Chưa biết"
			end
			Wnd_SetTip(self.UIGROUP, self.PORTRAIT_WND[i][2], string.format("Cấp: %d; %s; %s", tbMember[i].nLevel, szFaction, szName));
			
			if tbMember[i].nOnline == 0 then
				Txt_SetTxtColor(self.UIGROUP, self.PORTRAIT_WND[i][5], 0xc0c0c0);
				Img_SetFrame(self.UIGROUP, self.PORTRAIT_WND[i][2], 1);
			else
				Txt_SetTxtColor(self.UIGROUP, self.PORTRAIT_WND[i][5], 0x80d0a0);
				Img_SetFrame(self.UIGROUP, self.PORTRAIT_WND[i][2], 0);
			end
		else
 			Wnd_Hide(self.UIGROUP, self.PORTRAIT_WND[i][1]);
		end
	end
	
	local nMemberCount = #tbMember;
	local tbZhenFa = me.GetZhenFaInfo();
	
	if (not tbZhenFa) then
		Wnd_Hide(self.UIGROUP, self.ZHENFA_WND[1]);
		return;
	end;
	if (nZhenFaChange == 1) then
		local tbZhenFa = me.GetZhenFaInfo();
		if (not tbZhenFa) then
			Wnd_Hide(self.UIGROUP, self.ZHENFA_WND[1]);
			return;
		end;
		Wnd_SetPos(self.UIGROUP, self.ZHENFA_WND[1], 2, (nMemberCount + 1) * 34);
		Img_SetImage(self.UIGROUP, self.ZHENFA_WND[1], 1, self.ZHENGFA_SPR[tbZhenFa.nLevel + 1]);
		Wnd_Show(self.UIGROUP, self.ZHENFA_WND[1]);
		
		local nWidth1, nHeight1 = Wnd_GetSize(self.UIGROUP, self.ZHENFA_WND[1]);
		local nWidth2, nHeight2 = Wnd_GetSize(self.UIGROUP, self.ZHENFA_WND[2]);
		Wnd_SetPos(self.UIGROUP, self.ZHENFA_WND[2], 2 - (nHeight2 - nHeight1) / 2, (nMemberCount + 1) * 34 - (nWidth2 - nWidth1) / 2);
		Wnd_Show(self.UIGROUP, self.ZHENFA_WND[2]);
	 	Img_PlayAnimation(self.UIGROUP, self.ZHENFA_WND[2]);
	end;

end

function uiTeamPortrait:MinProtraitWindow()
	if self.m_bHidePortrait == 1 then
		Wnd_Show(self.UIGROUP, self.PORTRAIT_WINDOW);
		self.m_bHidePortrait = 0;
	else
		Wnd_Hide(self.UIGROUP, self.PORTRAIT_WINDOW);
		self.m_bHidePortrait = 1;
	end
end

function uiTeamPortrait:OnPopUpMenu(szWnd,	nParam)
	local nPlayer = nil;											-- 判断菜单属于第几个队友
	for i = 1, #self.PORTRAIT_WND do
		for j = 1, #self.PORTRAIT_WND[i] do
			if szWnd == self.PORTRAIT_WND[i][j] then
				nPlayer = i;
				break;
			end
		end	
	end
	if (nPlayer) then
		local tbMember = me.GetTeamMemberInfo();
		if tbMember[nPlayer].nOnline ~= 0 then						-- 如果在线者弹出菜单             
			local tbRelationList, _ = me.Relation_GetRelationList();
			local bFriend, bTeamLeader = 0, 0;
			if tbRelationList and tbRelationList[Player.emKPLAYERRELATION_TYPE_BIDFRIEND] then
				local tbFrined = tbRelationList[Player.emKPLAYERRELATION_TYPE_BIDFRIEND];
				for szPlayer, _ in pairs(tbFrined) do      			-- 判断是否好友
					if (tbMember[nPlayer].szName == szPlayer) then
						bFriend = 1;                  				-- 是自己好友
					end
				end
			end
			
			
			if tbRelationList and tbRelationList[Player.emKPLAYERRELATION_TYPE_TMPFRIEND] then
				local tbTmpFrined = tbRelationList[Player.emKPLAYERRELATION_TYPE_TMPFRIEND]; -- 判断是否是临时好友
				for szPlayer, _ in pairs(tbTmpFrined) do      			
					if (tbMember[nPlayer].szName == szPlayer) then
						bFriend = 1;                  									 -- 是自己临时好友
					end
				end
			end
			
			
			if (self:IsTeamLeader() == 1)  then
					bTeamLeader = 1;								-- 自己不是队长
			end 
			self.tbMenuFun[9] = tbMember[nPlayer];					-- 被选中的玩家信息放入 第9项
			if (bFriend == 0) and (bTeamLeader == 0) then			-- 显示加为好友, 不显示队长移交和踢出队伍
				self.tbMenuFun[6] = {self.CmdAddFriend}
				DisplayPopupMenu(self.UIGROUP, szWnd, 7, nParam,
					self.MENU_ITEM[1], 1,
					self.MENU_ITEM[2], 2,
					self.MENU_ITEM[3], 3,
					self.MENU_ITEM[4], 4,
					self.MENU_ITEM[5], 5,
					self.MENU_ITEM[6], 6,
					self.MENU_ITEM[9], 7
				);	
			end
			if (bFriend == 0) and (bTeamLeader == 1) then			-- 显示加为好友, 显示队长移交和踢出队伍
				self.tbMenuFun[6] = {self.CmdAddFriend}
				self.tbMenuFun[7] = {self.CmdChangeLeader}
				self.tbMenuFun[8] = {self.CmdKickOut}
				DisplayPopupMenu(self.UIGROUP, szWnd, 8, nParam,
					self.MENU_ITEM[1], 1,
					self.MENU_ITEM[2], 2,
					self.MENU_ITEM[3], 3,
					self.MENU_ITEM[4], 4,
					self.MENU_ITEM[5], 5,
					self.MENU_ITEM[6], 6,
					self.MENU_ITEM[7], 7,
					self.MENU_ITEM[8], 8,
					self.MENU_ITEM[9], 7
				);	
			end
			if (bFriend == 1) and (bTeamLeader == 0) then			-- 不显示加为好友, 不显示队长移交和踢出队伍
				DisplayPopupMenu(self.UIGROUP, szWnd, 5, nParam,
					self.MENU_ITEM[1], 1,
					self.MENU_ITEM[2], 2,
					self.MENU_ITEM[3], 3,
					self.MENU_ITEM[4], 4,
					self.MENU_ITEM[5], 5,
					self.MENU_ITEM[9], 7
				);	
			end
			if (bFriend == 1) and (bTeamLeader == 1) then			-- 不显示加为好友, 显示队长移交和踢出队伍
				self.tbMenuFun[6] = {self.CmdChangeLeader}
				self.tbMenuFun[7] = {self.CmdKickOut}
				DisplayPopupMenu(self.UIGROUP, szWnd, 7, nParam,
					self.MENU_ITEM[1], 1,
					self.MENU_ITEM[2], 2,
					self.MENU_ITEM[3], 3,
					self.MENU_ITEM[4], 4,
					self.MENU_ITEM[5], 5,
					self.MENU_ITEM[7], 6,
					self.MENU_ITEM[8], 7,
					self.MENU_ITEM[9], 7
				);	
			end
		end
	end
	
end

function uiTeamPortrait:OnMenuItemSelected(szWnd, nItemId, nListIndex)
	if nItemId and nItemId <= #self.MENU_ITEM then
		if self.tbMenuFun[nItemId] then
			self.tbMenuFun[nItemId][1](self, self.tbMenuFun[9]);
		end
	end
end

function uiTeamPortrait:CmdChat(tbMemberPlayer)
	if tbMemberPlayer then
		ChatToPlayer(tbMemberPlayer.szName);
	end
end

function uiTeamPortrait:CmdOTT(tbMemberPlayer)
	if tbMemberPlayer then
		local bSucess = 1;
		local pNpc = KNpc.GetByPlayerId(tbMemberPlayer.nPlayerID);
		if pNpc then
			bSucess = me.CallServerScript({"Send_Post_Player_OTT",pNpc.dwId,pNpc.szName});
		end
		if (bSucess == 0) or (not pNpc) then
			me.Msg("Khoảng cách 2 người quá xa!")
		end
	end
	
end

function uiTeamPortrait:CmdViewPlayer(tbMemberPlayer)
	if tbMemberPlayer then
		local bSucess = 1;
		local pNpc = KNpc.GetByPlayerId(tbMemberPlayer.nPlayerID);
		if pNpc then
			bSucess = ProcessNpcById(pNpc.dwId, UiManager.emACTION_VIEWITEM);
		end
		if (bSucess == 0) or (not pNpc) then
			me.Msg("Muốn xem thông tin của người chơi này nhưng cách nhau quá xa!")
		end
	end;
end

function uiTeamPortrait:CmdTrade(tbMemberPlayer)
	
	if tbMemberPlayer then
		local bSucess = 1;
		local pNpc = KNpc.GetByPlayerId(tbMemberPlayer.nPlayerID);
		if pNpc then
			bSucess = ProcessNpcById(pNpc.dwId, UiManager.emACTION_TRADE);
			me.Msg(""..pNpc.szName);
		end
		if (bSucess == 0) or (not pNpc) then
			me.Msg("Muốn giao dịch với người chơi này nhưng cách nhau quá xa!")
		end
	end;

end


function uiTeamPortrait:CmdFollow(tbMemberPlayer)
	local bSucess = 1;
	if tbMemberPlayer then
		self:CBFollow(tbMemberPlayer.nPlayerID);
	end;
end

function uiTeamPortrait:CBFollow(nPlayerId)
	local pNpc = KNpc.GetByPlayerId(nPlayerId);
	if pNpc then	-- 距离很近，尝试直接跟随
		if (ProcessNpcById(pNpc.dwId, UiManager.emACTION_FOLLOW) == 1) then
			return;
		end
	end
	local tbMember	= me.GetTeamMemberInfo();
	for _, tbMemberPlayer in ipairs(tbMember) do
		if (tbMemberPlayer.nPlayerID == nPlayerId) then
			local tbPos	= {
				nMapId	= tbMemberPlayer.nMapId,
			};
			for _, tbNpc in ipairs(SyncNpcInfo() or {}) do
				if (tbNpc.szName == tbMemberPlayer.szName) then
					tbPos.nX	= tbNpc.nX / 2;
					tbPos.nY	= tbNpc.nY;
					break;
				end
			end
			Ui.tbLogic.tbAutoPath:GotoPos(tbPos, self.CBFollow, self, nPlayerId);
			return;
		end
	end
	me.Msg("Người chơi này đã biến mất tăm!")
end

function uiTeamPortrait:CmdLeaveTeam(tbMemberPlayer)
	me.TeamLeave();
end

function uiTeamPortrait:CmdAddFriend(tbMemberPlayer)
	local bSucess = 1;
	if tbMemberPlayer then
		local pNpc = KNpc.GetByPlayerId(tbMemberPlayer.nPlayerID);
		if pNpc then
			bSucess = ProcessNpcById(pNpc.dwId, UiManager.emACTION_MAKEFRIEND);
		end
		
		if(bSucess == 0) or (not pNpc) then
			me.Msg("Muốn thêm người chơi này thành hảo hữu nhưng cách nhau quá xa!")
		end
	end;
end

function uiTeamPortrait:CmdChangeLeader(tbMemberPlayer)
	if tbMemberPlayer then
		me.TeamAppoint(tbMemberPlayer.nPlayerID);
	end;
end

function uiTeamPortrait:CmdKickOut(tbMemberPlayer)
	if tbMemberPlayer then
		me.TeamKick(tbMemberPlayer.nPlayerID);
	end
end

function uiTeamPortrait:IsTeamLeader()
	local tbMember = me.GetTeamMemberInfo();
	if tbMember then
		for i = 1, #tbMember do
			if tbMember[i].nLeader == 1 then
				return 0;
			end
		end
	end
	return 1;
end;

function uiTeamPortrait:RegisterEvent()
	local tbRegEvent = 
	{
		{ UiNotify.emCOREEVENT_TEAM_MEMBER_CHANGED,	self.UpdateMemberData },
	};
	return tbRegEvent;
end


function uiTeamPortrait:OnMouseEnter(szWnd)
	
	if (szWnd ~= self.ZHENFA_WND[1]) then
		return;
	end;
	
	local tbZhenFa = me.GetZhenFaInfo();
	if (not tbZhenFa) then
		return;
	end;
	
	local szMsg = self:GetZhenFaDesc(tbZhenFa.nNearSkillId, tbZhenFa.nMapSkillId, tbZhenFa.nLevel);
	szMsg = string.format("<color=yellow>%s<color>\n\n", tbZhenFa.szName) .. szMsg;
	szMsg = string.gsub(szMsg, "Thời gian duy trì: <color=gold>%d* giây<color>\n", "");
	Wnd_ShowMouseHoverInfo(self.UIGROUP, self.ZHENFA_WND[1], "", szMsg);
end;

function uiTeamPortrait:OnAnimationOver(szWnd)

	if (szWnd == self.ZHENFA_WND[2]) then
		Wnd_Hide(self.UIGROUP, self.ZHENFA_WND[2]);	-- 播放完毕，隐藏图像
	end
end

function uiTeamPortrait:GetZhenFaDesc(nNearSkillId, nMapSkillId, nLevel)
	local tbZhen = Item:GetClass("zhen");
	
	local szCurMsg = "";
	if (nLevel == 0) then
		szCurMsg = "<color=cyan>Chưa kích hoạt trận pháp này<color>\n\n";
	end;
	if (nLevel > 0) then
		if (nLevel < 5) then
			szCurMsg = string.format("<color=cyan>Cấp kích hoạt trận pháp này: <color><color=cyan>Cấp %s<color>\n", nLevel);
		else
			nLevel = 5;
			szCurMsg = string.format("<color=cyan>Cấp kích hoạt trận pháp này: <color><color=cyan>Cấp %s<color> [<color=red>Cấp cao nhất<color>]\n", nLevel);
		end;
		if (nNearSkillId > 0) then
			local szInfo = self:GetZhenFaSkillInfo(nNearSkillId, nLevel);
			szCurMsg = szCurMsg .. "<color=green>Hiệu quả cự ly gần<color>\n" .. szInfo .. "\n";
		end;
		if (nMapSkillId > 0) then
			local szInfo = self:GetZhenFaSkillInfo(nMapSkillId, nLevel);
			szCurMsg = szCurMsg .. "<color=green>Hiệu quả toàn bản đồ<color>\n" .. szInfo .. "\n\n";
		end;
	end;
	
	local szNextMsg = "";
	if (nLevel < 5) then
		szNextMsg = string.format("<color=cyan>Cấp kích hoạt trận pháp kế: <color><color=cyan>Cấp %s<color>\n", nLevel + 1);
		if (nNearSkillId > 0) then
			local szInfo = self:GetZhenFaSkillInfo(nNearSkillId, nLevel + 1);
			szNextMsg = szNextMsg .."<color=green>Hiệu quả cự ly gần<color>\n" ..  szInfo .. "\n";
		end;
		if (nMapSkillId > 0) then
			local szInfo = self:GetZhenFaSkillInfo(nMapSkillId, nLevel + 1);
			szNextMsg = szNextMsg .."<color=green>Hiệu quả toàn bản đồ<color>\n" .. szInfo .. "\n";
		end;
	end;
	return szCurMsg .. szNextMsg;
end;

function uiTeamPortrait:GetZhenFaSkillInfo(nSkillId, nLevel)
	local tbInfo = nil;

	if (nLevel > 0) then
		tbInfo	= KFightSkill.GetSkillInfo(nSkillId, nLevel);
	else
		nLevel	= 0;
	end
	
	if (not tbInfo) then
		return;
	end
	
	local szClassName = tbInfo.szClassName;
	local tbSkill = assert(FightSkill.tbClass[szClassName], "Skill{"..szClassName.."} bot found!");	
	local tbMsg = {};
	tbSkill:GetDescAboutLevel(tbMsg, tbInfo);
	return table.concat(tbMsg, "\n").."\n";
end;

function uiTeamPortrait:GetMemberTalk(szSendName, szMsg)
	local tbMember = me.GetTeamMemberInfo();
	local nNowTalk = 0;
	
	for i=1, #tbMember do
		if tbMember[i].szName == szSendName then
			nNowTalk = i;
			break;
		end
	end
	
	if nNowTalk == 0 then return; end
	
	local szShowMsg = self:GetFormatMsg(szMsg);
	
	if tbMember[nNowTalk].nLeader == 1 then
		Txt_SetTxt(self.UIGROUP, self.PO_WND[nNowTalk][2], "<color=orange>"..szShowMsg.."<color>");
	else
		Txt_SetTxt(self.UIGROUP, self.PO_WND[nNowTalk][2], "<color=white>"..szShowMsg.."<color>");
	end;
	
	Wnd_Show(self.UIGROUP, self.PO_WND[nNowTalk][1]);
	self.tbTalkTime[nNowTalk] = self.TIME_TALKPOPSHOWTIME;
end

function uiTeamPortrait:HideTalk()
	for nNowTalk, tbInfo in ipairs(self.PO_WND) do
		local nTimeCount = self.tbTalkTime[nNowTalk];
		if (nTimeCount > 0) then
			nTimeCount = nTimeCount - 1;
			if (0 >= nTimeCount) then
				Wnd_Hide(self.UIGROUP, tbInfo[1]);
			end
			self.tbTalkTime[nNowTalk] = nTimeCount;
		end
	end
	return;
end

function uiTeamPortrait:GetFormatMsg(szMsg)
	local szRead, szShow	= "", "";
	
	local nByte = 0;
	local szTempMsg 		= szMsg;
	local nMsgLen			= string.len(szMsg);

	while (string.len(szShow) < 26) do
		local nStart, nEnd	= 1, 1;
		local szRead		= string.sub(szTempMsg, nStart, nEnd);
		local nByte			= string.byte(szRead);
		local nSpcFlag		= 0;
		
		if nByte >= 128 then
			nEnd = nEnd + 1;
			szRead = string.sub(szTempMsg, nStart, nEnd);
		else
			if szRead == "<" then
				local nPicStart, nPicEnd, _nSpText = string.find(szTempMsg, ">");
				if nPicStart and nPicEnd then
					szRead 	= string.sub(szTempMsg, nStart, nPicEnd);
					local nTempEnd = nStart + 4;
					local szTempPic = string.sub(szTempMsg, nStart, nTempEnd);
					if (szTempPic ~= "<pic=") then
						nSpcFlag = 1;
					end
				end;
			else
				szRead 	= string.sub(szTempMsg, nStart, nEnd);
			end;
		end;
		
		if (1 == nSpcFlag) then
			szShow = szShow.."...";
		else
			szShow = szShow..szRead;
		end
		nStart	= string.len(szRead) + 1;
		nMsgLen = nMsgLen - string.len(szRead);
		if nStart > string.len(szTempMsg) then 
			break; 
		end;
		szTempMsg = string.sub(szTempMsg, nStart);
	end;

	if 0 < nMsgLen then
		szShow = szShow.."...";
	end;

	return szShow;
end
